"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var rest_1 = __importDefault(require("@octokit/rest"));
var graphql_1 = require("./graphql");
var logging_1 = require("./logging");
var pagination_1 = require("./pagination");
var rate_limiting_1 = require("./rate-limiting");
/**
 * the [@octokit/rest Node.js module](https://github.com/octokit/rest.js),
 * which wraps the [GitHub API](https://developer.github.com/v3/) and allows
 * you to do almost anything programmatically that you can do through a web
 * browser.
 * @see {@link https://github.com/octokit/rest.js}
 */
function GitHubAPI(options) {
    if (options === void 0) { options = {}; }
    var octokit = new rest_1.default(options);
    rate_limiting_1.addRateLimiting(octokit, options.limiter);
    logging_1.addLogging(octokit, options.logger);
    pagination_1.addPagination(octokit);
    graphql_1.addGraphQL(octokit);
    return octokit;
}
exports.GitHubAPI = GitHubAPI;
var graphql_2 = require("./graphql");
exports.GraphQLQueryError = graphql_2.GraphQLQueryError;
//# sourceMappingURL=index.js.map